//+------------------------------------------------------------------+
//|                                           FFS_Correlation_v2.mq4 |
//|                           Fixed by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |    
//+------------------------------------------------------------------+
#property copyright "icm63 (user name at Forex-TSD)"
#property link      "Forex-TSD"

/* 

This is the index selection format
1. EUR/USD, USD/CHF
2. EUR/USD, USD/CHF, GBP/USD
3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
4. EUR/USD, USD/CHF, USD/JPY
5. EUR/USD, GBP/USD, USD/JPY
6. USD/CHF, GBP/USD
7. USD/CHF, GBP/USD, USD/JPY
8. GBP/USD, USD/JPY


*/

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 White
#property indicator_color3 Lime
#property indicator_color4 Orange

//User Inputs Parameters
extern int IndexType = 3;
extern int Period_Short = 7;
extern int Period_Medium = 25;
extern int Period_Long = 75;

//---- variables
double USDcorrS[];
double USDcorrM[];
double USDcorrL[];
double Zero[];
double USDpos[];
double USDneg[];
double normUSDpos[];
double normUSDneg[];


int init()
{
   IndicatorShortName("FFS_Correlation Above Poor, Below Good.");
   
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Zero);
   SetIndexLabel(0,"Zero");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,USDcorrS);
   SetIndexLabel(1,"Corr_Short");
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,USDcorrM);
   SetIndexLabel(2,"Corr_Medium");
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,USDcorrL);
   SetIndexLabel(3,"Corr_Long");
   SetIndexBuffer(4,USDpos);
   SetIndexBuffer(5,USDneg);
   SetIndexBuffer(6,normUSDpos);
   SetIndexBuffer(7,normUSDneg);

   return(0);
}
//------------------------------------
int deinit()
{   
   return(0);
}
int start()
{      
   int limit;
   int counted_bars=IndicatorCounted();
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-1; 
      
   for(int i=limit; i>=0; i--)
   {
        switch(IndexType)
               {
               case 1:
                     //1. EUR/USD, USD/CHF"
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000;
                     break;
               case 2:
                     //2. EUR/USD, USD/CHF, GBP/USD
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000 + iClose("GBPUSD",0,i)  * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000;
                     break;
               case 3:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000 + iClose("GBPUSD",0,i)  * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 + iClose("USDJPY",0,i)  * 100 ;
                     break;
               case 4:
                     //4. EUR/USD, USD/CHF, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 + iClose("USDJPY",0,i)  * 100 ;
                     break;
               case 5:
                     //5. EUR/USD, GBP/USD, USD/JPY
                     USDpos[i]=   iClose("EURUSD",0,i) * 10000 + iClose("GBPUSD",0,i)  * 10000 ;
                     USDneg[i]=   iClose("USDJPY",0,i) * 100 ;
                     break;
               case 6:
                     //6. USD/CHF, GBP/USD
                     USDpos[i]=  iClose("GBPUSD",0,i) * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 ;
                     break;
               case 7:
                     //7. USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("GBPUSD",0,i) * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 + iClose("USDJPY",0,i)  * 100 ;
                     break;  
               case 8:
                     //8. GBP/USD, USD/JPY 
                     USDpos[i]=  iClose("GBPUSD",0,i) * 10000 ;
                     USDneg[i]=  iClose("USDJPY",0,i)  * 100 ;
                     break;
               default:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * 10000 + iClose("GBPUSD",0,i)  * 10000 ;
                     USDneg[i]=  iClose("USDCHF",0,i) * 10000 + iClose("USDJPY",0,i)  * 100 ;
                     break;
              }
              
              
               double MaxPos=-10000000, MinPos=10000000;
               double MaxNeg=-10000000, MinNeg=10000000;
       
              for ( int k=0; k<=limit-1;k++)
              {
                 if( USDpos[i+k] > MaxPos) MaxPos = USDpos[i+k];
                 if( USDpos[i+k] < MinPos) MinPos = USDpos[i+k];
                 if( USDneg[i+k] > MaxNeg) MaxNeg = USDneg[i+k];
                 if( USDneg[i+k] < MinNeg) MinNeg = USDneg[i+k];
              }
   }
       
   //Normalise Data btw 0 and 100
   for(int m=limit; m>=0; m--)
   {
     if (MaxPos - MinPos != 0) normUSDpos[m] = 100*(USDpos[m]-MinPos)/(MaxPos-MinPos);  
     if (MaxNeg - MinNeg != 0) normUSDneg[m] = 100*(USDneg[m]-MinNeg)/(MaxNeg-MinNeg); 
     Zero[m] = 0; //Had to put it somewhere !!!
   }
   CorrelationFx(USDcorrS,normUSDpos, normUSDneg,Period_Short,limit);
   CorrelationFx(USDcorrM,normUSDpos, normUSDneg,Period_Medium,limit);
   CorrelationFx(USDcorrL,normUSDpos, normUSDneg,Period_Long,limit);
   return(0);
}

//FUNCTIONS
void CorrelationFx(
double& OutArray[], 
double& normUSDpos[],
double normUSDneg[], 
double cPeriod, 
double nlimit)
{
   for(int i= nlimit; i>=0; i--)
   {       
   double SumXY  = 0;
   double SumX   = 0;
   double SumX2  = 0;
   double SumY   = 0;
   double SumY2  = 0;
   
   for(int k=0;k<=cPeriod-1;k++) 
   {
   SumXY += normUSDpos[i+k]*normUSDneg[i+k];
   SumX  += normUSDpos[i+k];
   SumY  += normUSDneg[i+k];
   SumX2 += normUSDpos[i+k]*normUSDpos[i+k];
   SumY2 += normUSDneg[i+k]*normUSDneg[i+k];
   }
   
   if((SumX2-SumX*SumX/cPeriod)*(SumY2-SumY*SumY/cPeriod)!=0) 
   OutArray[i] = (SumXY - SumX*SumY/cPeriod)/MathPow((SumX2-SumX*SumX/cPeriod)*(SumY2-SumY*SumY/cPeriod),0.5);        
   }
}
//+------------------------------------------------------------------+